BZOJ_4378_[POI2015]Logistyka_树状数组

Description

维护一个长度为n的序列,一开始都是0,支持以下两种操作:
1.U k a 将序列中第k个数修改为a。
2.Z c s 在这个序列上,每次选出c个正数,并将它们都减去1,询问能否进行s次操作。
每次询问独立,即每次询问不会对序列进行修改。

Input

第一行包含两个正整数n,m(1<=n,m<=1000000),分别表示序列长度和操作次数。
接下来m行为m个操作,其中1<=k,c<=n,0<=a<=10^9,1<=s<=10^9。

Output

包含若干行,对于每个Z询问,若可行,输出TAK,否则输出NIE。

Sample Input

3 8
U 1 5
U 2 7
Z 2 6
U 3 1
Z 2 6
U 2 2
Z 2 6
Z 2 1

Sample Output

NIE
TAK
NIE
TAK


需要注意查询是在整个序列上的而不是给定区间。

假设大于s的个数有k个,则剩下的那些权值和必须要大于等于(c-k)*s。

于是我们把权值离散化然后用两个树状数组分别维护。

代码:

#include <stdio.h>
#include <string.h>
#include <algorithm>
using namespace std;
#define N 1000050
#define RR register
typedef long long ll;
int n,m,t[N],maxn=1000000000,h[N],p[N];
ll c[N][2];
char opt[10];
inline int rd() {
    RR int x=0,f=1; RR char s=getchar();
    while(s<‘0‘||s>‘9‘){if(s==‘-‘)f=-1;s=getchar();}
    while(s>=‘0‘&&s<=‘9‘){x=(x<<3)+(x<<1)+s-‘0‘;s=getchar();}
    return x*f;
}
struct A {
    int num,v,id,opt,pos;
}a[N];
inline bool cmp1(const A &x,const A &y){return x.num<y.num;}
inline bool cmp2(const A &x,const A &y){return x.id<y.id;}
void fix(int x,int v,int flg) {
    for(;x<=m;x+=x&(-x)) c[x][flg]+=v;
}
ll inq(int x,int flg) {
    ll re=0;
    for(;x;x-=x&(-x)) re+=c[x][flg];
    return re;
}
int main() {
    n=rd(); m=rd();
    int i,j;
    for(i=1;i<=m;i++) {
        scanf("%s",opt);
        if(opt[0]==‘U‘) {
            a[i].opt=1; a[i].id=i; a[i].pos=rd(); a[i].num=rd();
        }else {
            a[i].opt=2; a[i].id=i; a[i].pos=rd(); a[i].num=rd();
        }
    }
    sort(a+1,a+m+1,cmp1); a[0].num=134234;
    for(j=0,i=1;i<=m;i++) {
        if(a[i].num!=a[i-1].num) j++;
        a[i].v=j;
        h[j]=a[i].num;
    }
    sort(a+1,a+m+1,cmp2);
    for(i=1;i<=m;i++) {
        if(a[i].opt==1) {
            int t=a[i].pos;
            if(p[t]) {
                fix(p[t],-1,1);
                fix(p[t],-h[p[t]],2);
            }
            p[t]=a[i].v;
            fix(p[t],1,1);
            fix(p[t],h[p[t]],2);
        }else {
            int k=inq(m,1)-inq(a[i].v-1,1);
            if(k>=a[i].pos) {
                puts("TAK"); continue;
            }
            ll sum=inq(a[i].v-1,2);
            puts(sum>=1ll*a[i].num*(a[i].pos-k)?"TAK":"NIE");
        }
    }
}

原文地址:https://www.cnblogs.com/suika/p/8967241.html

时间: 2024-08-08 20:41:41

BZOJ_4378_[POI2015]Logistyka_树状数组的相关文章

【BZOJ4378】[POI2015]Logistyka 树状数组

[BZOJ4378][POI2015]Logistyka Description 维护一个长度为n的序列,一开始都是0,支持以下两种操作:1.U k a 将序列中第k个数修改为a.2.Z c s 在这个序列上,每次选出c个正数,并将它们都减去1,询问能否进行s次操作.每次询问独立,即每次询问不会对序列进行修改. Input 第一行包含两个正整数n,m(1<=n,m<=1000000),分别表示序列长度和操作次数.接下来m行为m个操作,其中1<=k,c<=n,0<=a<=

【BZOJ4378】[POI2015]Logistyka【树状数组】【结论题】

[题目链接] 题解: 首先得有一个结论:设个数大于s的数字有k个(如果k大于c,显然是TAK.这里讨论k <= c),那么如果个数小于s的数字和不小于(c - k) * s,那么一定有解. 并不会证明... 用树状数组记录一下数字的个数以及数字的数字和,然后判断就可以了. 复杂度: 时间复杂度:O(mlogm),空间复杂度:O(m). 1A. GET: 结论题... /* Telekinetic Forest Guard */ #include <cstdio> #include <

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

(POJ 3067) Japan (慢慢熟悉的树状数组)

Japan Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 29295   Accepted: 7902 Description Japan plans to welcome the ACM ICPC World Finals and a lot of roads must be built for the venue. Japan is tall island with N cities on the East coas

【二维树状数组】See you~

https://www.bnuoj.com/v3/contest_show.php?cid=9148#problem/F [题意] 给定一个矩阵,每个格子的初始值为1.现在可以对矩阵有四种操作: A x y n1 :给格点(x,y)的值加n1 D x y n1: 给格点(x,y)的值减n1,如果现在格点的值不够n1,把格点置0 M x1 y1 x2 y2:(x1,y1)移动给(x2,y2)n1个 S x1 y1 x2 y2 查询子矩阵的和 [思路] 当然是二维树状数组 但是一定要注意:lowbi

Vijos P1066 弱弱的战壕【多解,线段树,暴力,树状数组】

弱弱的战壕 描述 永恒和mx正在玩一个即时战略游戏,名字嘛~~~~~~恕本人记性不好,忘了-_-b. mx在他的基地附近建立了n个战壕,每个战壕都是一个独立的作战单位,射程可以达到无限(“mx不赢定了?!?”永恒[email protected][email protected]). 但是,战壕有一个弱点,就是只能攻击它的左下方,说白了就是横纵坐标都不大于它的点(mx:“我的战壕为什么这么菜”ToT).这样,永恒就可以从别的地方进攻摧毁战壕,从而消灭mx的部队. 战壕都有一个保护范围,同它的攻击

CF 313 DIV2 B 树状数组

http://codeforces.com/contest/313/problem/B 题目大意 给一个区间,问你这个区间里面有几个连续相同的字符. 思路: 表示个人用树状数组来写的...了解了树状数组的本质就行了. 当然用sum[r]-sum[l]也是可以的

Hdu5032 极角排序+树状数组

题目链接 思路:参考了题解.对询问进行极角排序,然后用树状数组维护一下前缀和即可. /* ID: onlyazh1 LANG: C++ TASK: test */ #include<bits/stdc++.h> using namespace std; #define lson l,m,rt<<1 #define rson m+1,r,rt<<1|1 typedef long long ll; const int maxn=1010; const int maxm=10

Curious Robin Hood(树状数组+线段树)

1112 - Curious Robin Hood    PDF (English) Statistics Forum Time Limit: 1 second(s) Memory Limit: 64 MB Robin Hood likes to loot rich people since he helps the poor people with this money. Instead of keeping all the money together he does another tri